#include <gear/graphics/models.h>
#include <gear/memory.h>

#include <log.c/log.h>

g_model* g_model_create(g_vertex_vec* vertices, g_index_vec* indices) {
    g_model* model = g_mem_calloc_named("Model", sizeof(g_model));

    if(vertices != NULL) {
        for(sz i = 0; i < vertices->size; i++) {
            sl_vec_push(model->vertices, vertices->data[i]);
        }

        model->vertex_buffer = sg_make_buffer(&(sg_buffer_desc){
            .type = SG_BUFFERTYPE_VERTEXBUFFER,
            .data = SL_SG_RANGE(model->vertices)
        });
    }

    if(indices != NULL) {
        for(sz i = 0; i < indices->size; i++) {
            sl_vec_push(model->indices, indices->data[i]);
        }

        model->index_buffer = sg_make_buffer(&(sg_buffer_desc){
            .type = SG_BUFFERTYPE_INDEXBUFFER,
            .data = SL_SG_RANGE(model->indices)
        });
    }

    return model;
}
