#include <gear/graphics/renderer.h>
#include <gear/memory.h>

#include <log.c/log.h>

g_renderer* g_renderer_create(g_color clear_color) {
    sg_color_attachment_action color_action = {
        .load_action = SG_LOADACTION_CLEAR,
        .clear_value = G_COLOR_TO_FLOAT_ARR(clear_color),
    };

    g_renderer* renderer = g_mem_calloc_named("Renderer", sizeof(g_renderer));
    renderer->pass_action = (sg_pass_action){
        .colors = { color_action, color_action, color_action, color_action },
        .depth = { .load_action = SG_LOADACTION_CLEAR, .clear_value = 1.0f },
    };

    return renderer;
}
