#include <gear/memory.h>
#include <log.c/log.h>

void* g_mem_alloc_named(const char* resource, sz size) {
    void* ptr = MEM_ALLOC_FUNC(size);
    if(ptr != NULL) {
        if(resource != NULL) {
            log_info("%s allocated successfully (%zu bytes)", resource, size);
            log_debug("%s pointer: %p", resource, ptr);
        } else {
            log_info("%zu bytes allocated successfully", size);
            log_debug("Pointer: %p", ptr);
        }

        return ptr;
    } else {
        if(resource != NULL) {
            log_fatal("Failed to allocate %s (%zu bytes)", resource, size);
        } else {
            log_fatal("Failed to allocate %zu bytes", size);
        }

        exit(EXIT_FAILURE);
    }
}

void* g_mem_calloc_named(const char* resource, sz size) {
    void* ptr = g_mem_alloc_named(resource, size);
    memset(ptr, 0, size);
    if(resource != NULL) {
        log_info("Zeroed %zu bytes for %s", size, resource);
    } else {
        log_info("Zeroid %zu bytes", size);
    }

    return ptr;
}

void* g_mem_alloc(sz size) {
    return g_mem_alloc_named(NULL, size);
}

void* g_mem_calloc(sz size) {
    return g_mem_calloc_named(NULL, size);
}
